--- chan_sip.c.bak	2011-01-24 11:19:55.000000000 -0500
+++ chan_sip.c	2011-01-24 11:28:24.000000000 -0500
@@ -10598,8 +10598,16 @@
 			else
 				p->noncodeccapability &= ~AST_RTP_DTMF;
 			p->jointnoncodeccapability = p->noncodeccapability;
-			if (p->t38.peercapability)
-				p->t38.jointcapability &= p->t38.peercapability;
+
+                        /* Haldle T38 passthrough according to user setting */
+                        if (ast_test_flag(&user->flags[1],SIP_PAGE2_T38SUPPORT_UDPTL)) {
+                                if (p->t38.peercapability)
+                                        p->t38.jointcapability &= p->t38.peercapability;
+                        } else if (p->udptl) {
+                                ast_udptl_destroy(p->udptl);
+                                p->udptl = NULL;
+                        }
+
 			p->maxcallbitrate = user->maxcallbitrate;
 			/* If we do not support video, remove video from call structure */
 			if ((!ast_test_flag(&p->flags[1], SIP_PAGE2_VIDEOSUPPORT) || !(p->capability & AST_FORMAT_VIDEO_MASK)) && p->vrtp) {
@@ -10734,8 +10742,15 @@
 				else
 					p->noncodeccapability &= ~AST_RTP_DTMF;
 				p->jointnoncodeccapability = p->noncodeccapability;
-				if (p->t38.peercapability)
-					p->t38.jointcapability &= p->t38.peercapability;
+
+                                /* Haldle T38 passthrough according to user setting */
+                                if (ast_test_flag(&peer->flags[1],SIP_PAGE2_T38SUPPORT_UDPTL)) {
+                                        if (p->t38.peercapability)
+                                                p->t38.jointcapability &= p->t38.peercapability;
+                                } else if (p->udptl) {
+                                        ast_udptl_destroy(p->udptl);
+                                        p->udptl = NULL;
+                                }
 			}
 			ASTOBJ_UNREF(peer, sip_destroy_peer);
 		} else { 
